

#ifndef _CSMANAGER_H_
#define _CSMANAGER_H_

// Client-Server manager

#include <qobject.h>
#include <qstring.h>

class MyServer;
class MyClient;


class CSManager : public QObject
{
	Q_OBJECT

public:

	enum StartingCode { ServerStarted = 0, UnknownServerFound = 1,
                        ServerDoesNotRespond = 2 };

	CSManager( int port, QString file_to_open = "",
               QObject * parent = 0, const char * name = 0 );
	~CSManager();

signals:
	void requestOpen(QString);
	void requestFunction(QString);

	// The GUI should continue start up (show, and open initial file)
	void mayStartUp(int);

	// Another instance is running, GUI should close
	void mayClose();

protected slots:
	// Called when we've connected to port.
	void connectedToPort();

	// Called if it's not possible to port.
	void notConnectedToPort();

	// Called when we've connected to another running instance of smplayer.
	void connectedToInstance();

	// Connection closed
	void connectionToInstanceClosed();

	// Connected to server, but it's not smplayer
	void connectedToUnknownServer();

	void serverDontRespond();

protected:
	MyServer * server;
	MyClient * client;
	int _port;
	QString _file_to_open;
};

#endif
